function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function constructBasedOff(obj) {
  if (obj.constructor) {
    return new obj.constructor();
  } else {
    // We can fallback to just cloning the prototype across if there's no constructor
    return objectWithPrototypeFrom(obj);
  }
}

function objectWithPrototypeFrom(obj) {
  return Object.assign(Object.create(Object.getPrototypeOf(obj)), obj);
}

function mockValue(realValue, options, ogToMockedMap) {
  const recursive = options.recursive;
  const classInstances = recursive ? recursive.classInstances : false;

  if (ogToMockedMap.has(realValue)) {
    return ogToMockedMap.get(realValue);
  }

  function handleContainer(createMockStubCallback, mockCallback) {
    // .size == 0 to see if we haven't done any recursion yet
    if (options.recursive || ogToMockedMap.size == 0) {
      const mocked = createMockStubCallback(realValue);
      ogToMockedMap.set(realValue, mocked);
      return mockCallback(realValue, mocked, options, ogToMockedMap);
    } else {
      return realValue;
    }
  }

  if (typeof realValue === 'function') {
    if (ogToMockedMap.has(realValue)) {}

    const mockedFn = jest.fn();
    ogToMockedMap.set(realValue, mockedFn);

    if (options.onMockedFunction) {
      options.onMockedFunction(mockedFn, realValue);
    }

    return mockedFn;
  } else if (realValue === null || realValue === undefined) {
    return realValue;
  } else if (realValue instanceof Map) {
    return handleContainer(constructBasedOff, mockMapValues);
  } else if (realValue instanceof Set) {
    return handleContainer(constructBasedOff, mockSetValues);
  } else if (Array.isArray(realValue) || Object.getPrototypeOf({}) === Object.getPrototypeOf(realValue) || Object.getPrototypeOf(exports) === Object.getPrototypeOf(realValue)) {
    // Mock fields in {...}
    return handleContainer(constructBasedOff, mockProperties);
  } else if (typeof realValue === 'object' && (classInstances || ogToMockedMap.size == 0)) {
    return handleContainer(objectWithPrototypeFrom, (realVal, mocked, opts, map) => {
      const mocked2 = mockPrototypeFunctions(realVal, mocked, opts, map);
      return mockProperties(realVal, mocked2, opts, map);
    });
  } else {
    return realValue;
  }
}

function mockPrototypeFunctions(value, mockedObject) {
  let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let ogToMockedMap = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : new Map();
  // This will map the prototype values to the mocked object and not other objects with the same prototype
  const prototype = Object.getPrototypeOf(value);

  if (prototype) {
    return mockProperties(prototype, mockedObject, options, ogToMockedMap);
  } else {
    return mockedObject;
  }
}

function mockProperties(value, mockedObject) {
  let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let ogToMockedMap = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : new Map();
  const propertyDescriptors = Object.getOwnPropertyDescriptors(value);
  Object.keys(propertyDescriptors).forEach(key => {
    const propertyDescriptor = propertyDescriptors[key];
    const mockedPropertyDescriptor = propertyDescriptor.get || propertyDescriptor.set ? _objectSpread({}, propertyDescriptor, {
      get: mockValue(propertyDescriptor.get, options, ogToMockedMap),
      set: mockValue(propertyDescriptor.set, options, ogToMockedMap)
    }) : _objectSpread({}, propertyDescriptor, {
      value: mockValue(propertyDescriptor.value, options, ogToMockedMap)
    });
    Object.defineProperty(mockedObject, key, mockedPropertyDescriptor);
  });
  return mockedObject;
}

function mockMapValues(actualMap, mockedMap) {
  let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let ogToMockedMap = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : new Map();

  for (const _ref of actualMap.entries()) {
    var _ref2 = _slicedToArray(_ref, 2);

    const key = _ref2[0];
    const value = _ref2[1];
    mockedMap.set(key, mockValue(value, options, ogToMockedMap));
  }

  return mockedMap;
}

function mockSetValues(actualSet, mockedSet) {
  let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let ogToMockedMap = arguments.length > 3 ? arguments[3] : undefined;

  for (const value of actualSet) {
    mockedSet.add(mockValue(value, options, ogToMockedMap));
  }

  return mockedSet;
}

export function mockFunctions(value) {
  let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  let ogToMockedMap = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : new Map();
  return mockValue(value, options, ogToMockedMap);
}
export default mockFunctions;
//# sourceMappingURL=index.js.map